
########################################################################################################################
# Copyright (c) 2015, University of Osnabrueck                                                                         #
#   All rights reserved.                                                                                               #
#                                                                                                                      #
#   Redistribution and use in source and binary forms, with or without modification, are permitted provided that the   #
#   following conditions are met:                                                                                      #
#                                                                                                                      #
#   1. Redistributions of source code must retain the above copyright notice, this list of conditions and the following#
#       disclaimer.                                                                                                    #
#                                                                                                                      #
#   2. Redistributions in binary form must reproduce the above copyright notice, this list of conditions and the       #
#       following disclaimer in the documentation and/or other materials provided with the distribution.               #
#                                                                                                                      #
#   THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, #
#   INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE  #
#   DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, #
#   SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR    #
#   SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY,  #
#   WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE   #
#   USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.                                           #
########################################################################################################################
import numpy as np
from StringIO import StringIO
import sys

import src.globals as gl

def removeOffset(filename, outfilename, center=None):
    gl.logger.debug("parsing...")
    vertices = []

    if center is None:
        f = open(filename)
        acc = None
        for l in f:
            inarr = np.genfromtxt(StringIO(l), delimiter=" ")
            if acc is None:
                acc = [inarr[0:3]]
            else:
                acc = np.append(acc, [inarr[0:3]], axis=0)
        f.close()
        #print acc
        center = None

        #print acc

        if acc == None:
            center = [0, 0, 0]
        else:
            center = np.mean(acc, axis=0)

            #tmp = center[1]
            #center[1] = center[0]
            #center[0] = tmp
    gl.logger.debug("...got center...")
    gl.logger.info("Center: " + str(center))

    f = open(filename)
    fout = open(outfilename, "w")
    i = 0
    for l in f:
        inarr = np.genfromtxt(StringIO(l), delimiter=" ")

        #print "before: ", inarr[0], center[0]
        #remove offset to avoid floating precision problems
        inarr = [inarr - np.tile(center, len(inarr) / 3)]
        #print "after: ", inarr[0][0]
        np.savetxt(fout, inarr)
        i += 1
    gl.logger.debug(str(i) + " polygons")
    f.close()
    fout.close()

